# Amethyst - An experimental Minecraft server written in Elixir.
# Copyright (C) 2024 KodiCraft
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

defmodule Amethyst.Server.Generic do
  @moduledoc """
  This module includes generic logic which may be used by all stages of the server, including,
  for instance, listening for packets.
  """

  alias Amethyst.Minecraft.Read

  def get_packet(client) do

  end

  defp get_varint(client, acc) do
    {:ok, byte} = :gen_tcp.recv(client, 1)
    case byte do
      <<0::1, _::7>> -> Read.start(acc <> byte) |> Read.varint() |> Read.stop()
      <<1::1, _::7>> -> get_varint(client, acc <> byte)
    end
  end
end
